import BN from 'bn.js';
import { Client } from '../client';
import { Contract } from '../contract';
import { Address } from '../address';
export interface ICandidate {
    address: Address;
    pubKey: Uint8Array;
}
export interface IValidator {
    pubKey: Uint8Array;
    power: number;
}
export interface IDelegation {
    validator: Address;
    delegator: Address;
    height: BN;
    amount: BN;
}
export interface IWitness {
    pubKey: Uint8Array;
    voteTotal: BN;
    powerTotal: BN;
}
export declare class DPOS2 extends Contract {
    static createAsync(client: Client, callerAddr: Address): Promise<DPOS2>;
    constructor(params: {
        contractAddr: Address;
        callerAddr: Address;
        client: Client;
    });
    getCandidatesAsync(): Promise<Array<ICandidate>>;
    getValidatorsAsync(): Promise<Array<IValidator>>;
    checkDelegationAsync(validator: Address, delegator: Address): Promise<IDelegation | null>;
    delegateAsync(validator: Address, amount: BN | number | string): Promise<void>;
    unbondAsync(validator: Address, amount: BN | number | string): Promise<void>;
}
